#!/usr/bin/perl -w

use strict;
use POSIX qw(strftime);

use DBI;

my $data_source;
my $username;
my $auth;
my @ips;
open (RC, "${ENV{HOME}}/.pingemall") or die "cannot open rc file ${ENV{HOME}}/.pingemall: $!\n";
undef $/;
my $rc = <RC>;
close (RC);
$/ = "\n";
eval $rc;

#print STDERR "data_source = $data_source\n";

my $dbh = DBI->connect($data_source, $username, $auth);
#print time(), "\n";
my $sth = $dbh->prepare("alter session  set nls_date_format='YYYY-MM-DD HH24:MI:SS'");
my $rv = $sth->execute;
#print STDERR "alter session: $rv\n";

chdir "$ENV{'HOME'}/stat" or die "cannot chdir ${ENV{HOME}}/stat:$!\n";
$ENV{'PATH'} = "/usr/sbin:/usr/local/bin:${ENV{'PATH'}}";

while (<>) {
    chomp;
    my ($ip, $pckt_xmit, $pckt_recv, $pckt_loss_pct,
	$rtt_min, $rtt_avg, $rtt_max) = split(/\t/);
    my $timestamp = strftime "%Y-%m-%d %H:%M:%S", localtime;
    my $cmnd = "insert into stat_ping(ip, timestamp, pckt_xmit, pckt_recv, pckt_loss_pct, rtt_min, rtt_avg, rtt_max) values (" .
               $dbh->quote($ip) .  ", " . $dbh->quote($timestamp) .
	       ", $pckt_xmit, $pckt_recv, $pckt_loss_pct, $rtt_min, $rtt_avg, $rtt_max)";
    #print STDERR $cmnd, "\n";
    $sth = $dbh->prepare($cmnd);
    $rv = $sth->execute;
    #print STDERR "insert: $rv\n";
    #if (!$rv) { exit 1 }
}

