#!/usr/bin/perl -w

use strict;
use POSIX qw(strftime);

my $data_source;
my $username;
my $auth;
my @ips;
open (RC, "${ENV{HOME}}/.pingemall") or die "cannot open rc file ${ENV{HOME}}/.pingemall: $!\n";
undef $/;
my $rc = <RC>;
close (RC);
$/ = "\n";
eval $rc;

for my $i (@ips) {
    if ($i =~ m/^(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
	my $ip = ($1 << 24) | ($2 << 16) | ($3 << 8) | $4;
	my $mask = ($5 << 24) | ($6 << 16) | ($7 << 8) | $8;
	my $min = $ip & $mask;
	my $max = $ip | ~$mask;
	for (my $j = $min; $j <= $max; $j++) {
	    my $thisip = sprintf("%d.%d.%d.%d",
				  ($j >> 24) & 0xFF,
				  ($j >> 16) & 0xFF,
				  ($j >>  8) & 0xFF,
				  ($j >>  0) & 0xFF);
	    #print STDERR "tryip: $thisip\n";
	    print "$thisip\n";
	}
	
    } elsif  ($i =~ m/(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)$/) {
	my $ip = ($1 << 24) | ($2 << 16) | ($3 << 8) | $4;
	my $mask = 0xFFFFFFFF << (32 - $5);
	my $min = $ip & $mask;
	my $max = $ip | ~$mask;
	for (my $j = $min; $j <= $max; $j++) {
	    my $thisip = sprintf("%d.%d.%d.%d",
				  ($j >> 24) & 0xFF,
				  ($j >> 16) & 0xFF,
				  ($j >>  8) & 0xFF,
				  ($j >>  0) & 0xFF);
	    #print STDERR "tryip: $thisip\n";
	    print "$thisip\n";
	}
    } elsif  ($i =~ m/(\d+)\.(\d+)\.(\d+)\.(\d+)/) {
	#print STDERR "tryip: $i\n";
	print "$i\n";
    } else {
	printf STDERR "$0: $i not an IP address or range\n";
    }
}
exit 0;
