#!/usr/bin/perl -wT

use strict;
use POSIX ":sys_wait_h";

# ping should be in there somewhere
$ENV{PATH} = "/bin:/usr/bin:/sbin:/usr/sbin";

while (<>) {
    chomp;
    next unless (/^(\d+\.\d+\.\d+\.\d+)$/);
    my $ip = $1;
    if (fork()) {
	my $kid;
	do {
	   $kid = waitpid(-1,&WNOHANG);
	    #print STDERR "reaped kid $kid\n";
	} until $kid <= 0;
	sleep 15
    } else {
	my ($pckt_xmit, $pckt_recv, $pckt_loss_pct,
	    $rtt_min, $rtt_avg, $rtt_max) = (0, 0, 0, 0, 0, 0);
	#print STDERR "executing ping -c 100 -q $ip\n";
	open (PINGOUT, "ping -c 100 -q $ip |");
	while (<PINGOUT>) {
	    #print STDERR;
	    if (/(\d+) packets transmitted, (\d+) packets received, (\d+)% packet loss/) {
		$pckt_xmit = $1;
		$pckt_recv = $2;
		$pckt_loss_pct = $3;
		#print STDERR "pkt: $pckt_xmit, $pckt_recv, $pckt_loss_pct\n";
	    }
	    if (m|round-trip min/avg/max = (\d+\.\d)/(\d+\.\d)/(\d+\.\d) ms|) {
		$rtt_min = $1;
		$rtt_avg = $2;
		$rtt_max = $3;
		#print STDERR "rtt: $rtt_min, $rtt_avg, $rtt_max\n";
	    }
	}
	close(PINGOUT);
	print $ip, "\t", $pckt_xmit, "\t", $pckt_recv, "\t",
	    $pckt_loss_pct, "\t", $rtt_min, "\t", $rtt_avg, "\t",
	    $rtt_max, "\n";
	exit(0);
    }
}
